com.microsoft.sqlserver.jdbc

## Class SQLServerPreparedStatement

- java.lang.Object
- - com.microsoft.sqlserver.jdbc.SQLServerStatement
  - - com.microsoft.sqlserver.jdbc.SQLServerPreparedStatement

All Implemented Interfaces:
  ISQLServerPreparedStatement, ISQLServerStatement, AutoCloseable, PreparedStatement, Statement, Wrapper

Direct Known Subclasses:
  SQLServerCallableStatement, SQLServerPreparedStatement42

    public class SQLServerPreparedStatement
    extends SQLServerStatement
    implements ISQLServerPreparedStatement

SQLServerPreparedStatement provides JDBC prepared statement functionality. SQLServerPreparedStatement provides methods for the user to supply parameters as any native Java type and many Java object types.
SQLServerPreparedStatement prepares a statement using SQL Server's sp_prepexec and re-uses the returned statement handle for each subsequent execution of the statement (typically using different parameters provided by the user)
SQLServerPreparedStatement supports batching whereby a set of prepared statements are executed in a single database round trip to improve runtime performance.
The API javadoc for JDBC API methods that this class implements are not repeated here. Please see Sun's JDBC API interfaces javadoc for those details.

### Field Summary

### Fields inherited from class com.microsoft.sqlserver.jdbc.SQLServerStatement

`stmtColumnEncriptionSetting`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`void` `addBatch()`
`void` `addBatch(String sql)`
`void` `clearBatch()`
`void` `clearParameters()`
`boolean` `execute()` Execute a query or non query statement.
`boolean` `execute(String sql)` Execute an update or query.
`int[]` `executeBatch()` Send a batch of statements to the database.
`long[]` `executeLargeBatch()`
`long` `executeLargeUpdate()`
`ResultSet` `executeQuery()` Execute a query.
`ResultSet` `executeQuery(String sql)` Execute a result set query
`int` `executeUpdate()` Execute a non query statement
`int` `executeUpdate(String sql)` Execute a JDBC update
`ResultSetMetaData` `getMetaData()`
`ParameterMetaData` `getParameterMetaData()`
`void` `setArray(int i, Array x)`
`void` `setAsciiStream(int parameterIndex, InputStream x)`
`void` `setAsciiStream(int n, InputStream x, int length)`
`void` `setAsciiStream(int parameterIndex, InputStream x, long length)`
`void` `setBigDecimal(int n, BigDecimal x)`
`void` `setBigDecimal(int n, BigDecimal x, int precision, int scale)`
`void` `setBigDecimal(int n, BigDecimal x, int precision, int scale, boolean forceEncrypt)`
`void` `setBinaryStream(int parameterIndex, InputStream x)`
`void` `setBinaryStream(int n, InputStream x, int length)`
`void` `setBinaryStream(int parameterIndex, InputStream x, long length)`
`void` `setBlob(int i, Blob x)`
`void` `setBlob(int parameterIndex, InputStream inputStream)`
`void` `setBlob(int parameterIndex, InputStream inputStream, long length)`
`void` `setBoolean(int n, boolean x)`
`void` `setBoolean(int n, boolean x, boolean forceEncrypt)`
`void` `setByte(int n, byte x)`
`void` `setByte(int n, byte x, boolean forceEncrypt)`
`void` `setBytes(int n, byte[] x)`
`void` `setBytes(int n, byte[] x, boolean forceEncrypt)`
`void` `setCharacterStream(int parameterIndex, Reader reader)`
`void` `setCharacterStream(int n, Reader reader, int length)`
`void` `setCharacterStream(int parameterIndex, Reader reader, long length)`
`void` `setClob(int parameterIndex, Clob clobValue)`
`void` `setClob(int parameterIndex, Reader reader)`
`void` `setClob(int parameterIndex, Reader reader, long length)`
`void` `setDate(int n, Date x)`
`void` `setDate(int n, Date x, Calendar cal)`
`void` `setDate(int n, Date x, Calendar cal, boolean forceEncrypt)`
`void` `setDateTime(int n, Timestamp x)`
`void` `setDateTime(int n, Timestamp x, boolean forceEncrypt)`
`void` `setDateTimeOffset(int n, DateTimeOffset x)`
`void` `setDateTimeOffset(int n, DateTimeOffset x, int scale)`
`void` `setDateTimeOffset(int n, DateTimeOffset x, int scale, boolean forceEncrypt)`
`void` `setDouble(int n, double x)`
`void` `setDouble(int n, double x, boolean forceEncrypt)`
`void` `setFloat(int n, float x)`
`void` `setFloat(int n, float x, boolean forceEncrypt)`
`void` `setInt(int n, int value)`
`void` `setInt(int n, int value, boolean forceEncrypt)`
`void` `setLong(int n, long x)`
`void` `setLong(int n, long x, boolean forceEncrypt)`
`void` `setMoney(int n, BigDecimal x)`
`void` `setMoney(int n, BigDecimal x, boolean forceEncrypt)`
`void` `setNCharacterStream(int parameterIndex, Reader value)`
`void` `setNCharacterStream(int parameterIndex, Reader value, long length)`
`void` `setNClob(int parameterIndex, NClob value)`
`void` `setNClob(int parameterIndex, Reader reader)`
`void` `setNClob(int parameterIndex, Reader reader, long length)`
`void` `setNString(int parameterIndex, String value)`
`void` `setNString(int parameterIndex, String value, boolean forceEncrypt)`
`void` `setNull(int index, int jdbcType)`
`void` `setNull(int paramIndex, int sqlType, String typeName)`
`void` `setObject(int index, Object obj)`
`void` `setObject(int n, Object obj, int jdbcType)`
`void` `setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength)`
`void` `setObject(int parameterIndex, Object x, int targetSqlType, Integer precision, int scale)`
`void` `setObject(int parameterIndex, Object x, int targetSqlType, Integer precision, int scale, boolean forceEncrypt)`
`void` `setRef(int i, Ref x)`
`void` `setRowId(int parameterIndex, RowId x)`
`void` `setShort(int index, short x)`
`void` `setShort(int index, short x, boolean forceEncrypt)`
`void` `setSmallDateTime(int n, Timestamp x)`
`void` `setSmallDateTime(int n, Timestamp x, boolean forceEncrypt)`
`void` `setSmallMoney(int n, BigDecimal x)`
`void` `setSmallMoney(int n, BigDecimal x, boolean forceEncrypt)`
`void` `setSQLXML(int parameterIndex, SQLXML xmlObject)`
`void` `setString(int index, String str)`
`void` `setString(int index, String str, boolean forceEncrypt)`
`void` `setStructured(int n, String tvpName, ISQLServerDataRecord tvpBulkRecord)`
`void` `setStructured(int n, String tvpName, ResultSet tvpResultSet)`
`void` `setStructured(int n, String tvpName, SQLServerDataTable tvpDataTbale)`
`void` `setTime(int n, Time x)`
`void` `setTime(int n, Time x, Calendar cal)`
`void` `setTime(int n, Time x, Calendar cal, boolean forceEncrypt)`
`void` `setTime(int n, Time x, int scale)`
`void` `setTime(int n, Time x, int scale, boolean forceEncrypt)`
`void` `setTimestamp(int n, Timestamp x)`
`void` `setTimestamp(int n, Timestamp x, Calendar cal)`
`void` `setTimestamp(int n, Timestamp x, Calendar cal, boolean forceEncrypt)`
`void` `setTimestamp(int n, Timestamp x, int scale)`
`void` `setTimestamp(int n, Timestamp x, int scale, boolean forceEncrypt)`
`void` `setUnicodeStream(int n, InputStream x, int length)` Deprecated.
`void` `setUniqueIdentifier(int index, String guid)`
`void` `setUniqueIdentifier(int index, String guid, boolean forceEncrypt)`
`void` `setURL(int parameterIndex, URL x)`

### Methods inherited from class com.microsoft.sqlserver.jdbc.SQLServerStatement

`cancel, clearWarnings, close, closeOnCompletion, execute, execute, execute, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResponseBuffering, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, isWrapperFor, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout, setResponseBuffering, toString, unwrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.sql.PreparedStatement

`setObject, setObject`

### Methods inherited from interface com.microsoft.sqlserver.jdbc.ISQLServerStatement

`getResponseBuffering, setResponseBuffering`

### Methods inherited from interface java.sql.Statement

`cancel, clearWarnings, close, closeOnCompletion, execute, execute, execute, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Method Detail

#### clearParameters

    public final void clearParameters()
                               throws SQLServerException

Specified by:
  `clearParameters` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### executeQuery

    public ResultSet executeQuery()
                           throws SQLServerException

Execute a query.

Specified by:
  `executeQuery` in interface `PreparedStatement`
Returns:
  ResultSet
Throws:
  `SQLServerException`

#### executeUpdate

    public int executeUpdate()
                      throws SQLServerException

Execute a non query statement

Specified by:
  `executeUpdate` in interface `PreparedStatement`
Returns:
  the update count of rows
Throws:
  `SQLServerException`

#### executeLargeUpdate

    public long executeLargeUpdate()
                            throws SQLServerException

Specified by:
  `executeLargeUpdate` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### execute

    public boolean execute()
                    throws SQLServerException

Execute a query or non query statement.

Specified by:
  `execute` in interface `PreparedStatement`
Returns:
  true if the statement returned a result set
Throws:
  `SQLServerException`

#### getMetaData

    public final ResultSetMetaData getMetaData()
                                        throws SQLServerException

Specified by:
  `getMetaData` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setAsciiStream

    public final void setAsciiStream(int parameterIndex,
                                     InputStream x)
                              throws SQLException

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setAsciiStream

    public final void setAsciiStream(int n,
                                     InputStream x,
                                     int length)
                              throws SQLServerException

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setAsciiStream

    public final void setAsciiStream(int parameterIndex,
                                     InputStream x,
                                     long length)
                              throws SQLException

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setBigDecimal

    public final void setBigDecimal(int n,
                                    BigDecimal x)
                             throws SQLServerException

Specified by:
  `setBigDecimal` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setBigDecimal

    public final void setBigDecimal(int n,
                                    BigDecimal x,
                                    int precision,
                                    int scale)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setBigDecimal

    public final void setBigDecimal(int n,
                                    BigDecimal x,
                                    int precision,
                                    int scale,
                                    boolean forceEncrypt)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setMoney

    public final void setMoney(int n,
                               BigDecimal x)
                        throws SQLServerException

Throws:
  `SQLServerException`

#### setMoney

    public final void setMoney(int n,
                               BigDecimal x,
                               boolean forceEncrypt)
                        throws SQLServerException

Throws:
  `SQLServerException`

#### setSmallMoney

    public final void setSmallMoney(int n,
                                    BigDecimal x)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setSmallMoney

    public final void setSmallMoney(int n,
                                    BigDecimal x,
                                    boolean forceEncrypt)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setBinaryStream

    public final void setBinaryStream(int parameterIndex,
                                      InputStream x)
                               throws SQLException

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setBinaryStream

    public final void setBinaryStream(int n,
                                      InputStream x,
                                      int length)
                               throws SQLServerException

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setBinaryStream

    public final void setBinaryStream(int parameterIndex,
                                      InputStream x,
                                      long length)
                               throws SQLException

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setBoolean

    public final void setBoolean(int n,
                                 boolean x)
                          throws SQLServerException

Specified by:
  `setBoolean` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setBoolean

    public final void setBoolean(int n,
                                 boolean x,
                                 boolean forceEncrypt)
                          throws SQLServerException

Throws:
  `SQLServerException`

#### setByte

    public final void setByte(int n,
                              byte x)
                       throws SQLServerException

Specified by:
  `setByte` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setByte

    public final void setByte(int n,
                              byte x,
                              boolean forceEncrypt)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setBytes

    public final void setBytes(int n,
                               byte[] x)
                        throws SQLServerException

Specified by:
  `setBytes` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setBytes

    public final void setBytes(int n,
                               byte[] x,
                               boolean forceEncrypt)
                        throws SQLServerException

Throws:
  `SQLServerException`

#### setUniqueIdentifier

    public final void setUniqueIdentifier(int index,
                                          String guid)
                                   throws SQLServerException

Throws:
  `SQLServerException`

#### setUniqueIdentifier

    public final void setUniqueIdentifier(int index,
                                          String guid,
                                          boolean forceEncrypt)
                                   throws SQLServerException

Throws:
  `SQLServerException`

#### setDouble

    public final void setDouble(int n,
                                double x)
                         throws SQLServerException

Specified by:
  `setDouble` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setDouble

    public final void setDouble(int n,
                                double x,
                                boolean forceEncrypt)
                         throws SQLServerException

Throws:
  `SQLServerException`

#### setFloat

    public final void setFloat(int n,
                               float x)
                        throws SQLServerException

Specified by:
  `setFloat` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setFloat

    public final void setFloat(int n,
                               float x,
                               boolean forceEncrypt)
                        throws SQLServerException

Throws:
  `SQLServerException`

#### setInt

    public final void setInt(int n,
                             int value)
                      throws SQLServerException

Specified by:
  `setInt` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setInt

    public final void setInt(int n,
                             int value,
                             boolean forceEncrypt)
                      throws SQLServerException

Throws:
  `SQLServerException`

#### setLong

    public final void setLong(int n,
                              long x)
                       throws SQLServerException

Specified by:
  `setLong` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setLong

    public final void setLong(int n,
                              long x,
                              boolean forceEncrypt)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setNull

    public final void setNull(int index,
                              int jdbcType)
                       throws SQLServerException

Specified by:
  `setNull` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setObject

    public final void setObject(int index,
                                Object obj)
                         throws SQLServerException

Specified by:
  `setObject` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setObject

    public final void setObject(int n,
                                Object obj,
                                int jdbcType)
                         throws SQLServerException

Specified by:
  `setObject` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setObject

    public final void setObject(int parameterIndex,
                                Object x,
                                int targetSqlType,
                                int scaleOrLength)
                         throws SQLServerException

Specified by:
  `setObject` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setObject

    public final void setObject(int parameterIndex,
                                Object x,
                                int targetSqlType,
                                Integer precision,
                                int scale)
                         throws SQLServerException

Throws:
  `SQLServerException`

#### setObject

    public final void setObject(int parameterIndex,
                                Object x,
                                int targetSqlType,
                                Integer precision,
                                int scale,
                                boolean forceEncrypt)
                         throws SQLServerException

Throws:
  `SQLServerException`

#### setShort

    public final void setShort(int index,
                               short x)
                        throws SQLServerException

Specified by:
  `setShort` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setShort

    public final void setShort(int index,
                               short x,
                               boolean forceEncrypt)
                        throws SQLServerException

Throws:
  `SQLServerException`

#### setString

    public final void setString(int index,
                                String str)
                         throws SQLServerException

Specified by:
  `setString` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setString

    public final void setString(int index,
                                String str,
                                boolean forceEncrypt)
                         throws SQLServerException

Throws:
  `SQLServerException`

#### setNString

    public final void setNString(int parameterIndex,
                                 String value)
                          throws SQLException

Specified by:
  `setNString` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNString

    public final void setNString(int parameterIndex,
                                 String value,
                                 boolean forceEncrypt)
                          throws SQLException

Throws:
  `SQLException`

#### setTime

    public final void setTime(int n,
                              Time x)
                       throws SQLServerException

Specified by:
  `setTime` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setTime

    public final void setTime(int n,
                              Time x,
                              int scale)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setTime

    public final void setTime(int n,
                              Time x,
                              int scale,
                              boolean forceEncrypt)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setTimestamp

    public final void setTimestamp(int n,
                                   Timestamp x)
                            throws SQLServerException

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setTimestamp

    public final void setTimestamp(int n,
                                   Timestamp x,
                                   int scale)
                            throws SQLServerException

Throws:
  `SQLServerException`

#### setTimestamp

    public final void setTimestamp(int n,
                                   Timestamp x,
                                   int scale,
                                   boolean forceEncrypt)
                            throws SQLServerException

Throws:
  `SQLServerException`

#### setDateTimeOffset

    public final void setDateTimeOffset(int n,
                                        DateTimeOffset x)
                                 throws SQLException

Specified by:
  `setDateTimeOffset` in interface `ISQLServerPreparedStatement`
Throws:
  `SQLException`

#### setDateTimeOffset

    public final void setDateTimeOffset(int n,
                                        DateTimeOffset x,
                                        int scale)
                                 throws SQLException

Throws:
  `SQLException`

#### setDateTimeOffset

    public final void setDateTimeOffset(int n,
                                        DateTimeOffset x,
                                        int scale,
                                        boolean forceEncrypt)
                                 throws SQLException

Throws:
  `SQLException`

#### setDate

    public final void setDate(int n,
                              Date x)
                       throws SQLServerException

Specified by:
  `setDate` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setDateTime

    public final void setDateTime(int n,
                                  Timestamp x)
                           throws SQLServerException

Throws:
  `SQLServerException`

#### setDateTime

    public final void setDateTime(int n,
                                  Timestamp x,
                                  boolean forceEncrypt)
                           throws SQLServerException

Throws:
  `SQLServerException`

#### setSmallDateTime

    public final void setSmallDateTime(int n,
                                       Timestamp x)
                                throws SQLServerException

Throws:
  `SQLServerException`

#### setSmallDateTime

    public final void setSmallDateTime(int n,
                                       Timestamp x,
                                       boolean forceEncrypt)
                                throws SQLServerException

Throws:
  `SQLServerException`

#### setStructured

    public final void setStructured(int n,
                                    String tvpName,
                                    SQLServerDataTable tvpDataTbale)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setStructured

    public final void setStructured(int n,
                                    String tvpName,
                                    ResultSet tvpResultSet)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setStructured

    public final void setStructured(int n,
                                    String tvpName,
                                    ISQLServerDataRecord tvpBulkRecord)
                             throws SQLServerException

Throws:
  `SQLServerException`

#### setUnicodeStream

    @Deprecated
    public final void setUnicodeStream(int n,
                                                    InputStream x,
                                                    int length)
                                             throws SQLException

Deprecated.

Specified by:
  `setUnicodeStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### addBatch

    public final void addBatch()
                        throws SQLServerException

Specified by:
  `addBatch` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### clearBatch

    public final void clearBatch()
                          throws SQLServerException

Specified by:
  `clearBatch` in interface `Statement`
Overrides:
  `clearBatch` in class `SQLServerStatement`
Throws:
  `SQLServerException`

#### executeBatch

    public int[] executeBatch()
                       throws SQLServerException,
                              BatchUpdateException

Description copied from class: `SQLServerStatement`
Send a batch of statements to the database.

Specified by:
  `executeBatch` in interface `Statement`
Overrides:
  `executeBatch` in class `SQLServerStatement`
Throws:
  `SQLServerException`
  `BatchUpdateException`

#### executeLargeBatch

    public long[] executeLargeBatch()
                             throws SQLServerException,
                                    BatchUpdateException

Specified by:
  `executeLargeBatch` in interface `Statement`
Overrides:
  `executeLargeBatch` in class `SQLServerStatement`
Throws:
  `SQLServerException`
  `BatchUpdateException`

#### setCharacterStream

    public final void setCharacterStream(int parameterIndex,
                                         Reader reader)
                                  throws SQLException

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setCharacterStream

    public final void setCharacterStream(int n,
                                         Reader reader,
                                         int length)
                                  throws SQLServerException

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setCharacterStream

    public final void setCharacterStream(int parameterIndex,
                                         Reader reader,
                                         long length)
                                  throws SQLException

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNCharacterStream

    public final void setNCharacterStream(int parameterIndex,
                                          Reader value)
                                   throws SQLException

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNCharacterStream

    public final void setNCharacterStream(int parameterIndex,
                                          Reader value,
                                          long length)
                                   throws SQLException

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setRef

    public final void setRef(int i,
                             Ref x)
                      throws SQLServerException

Specified by:
  `setRef` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setBlob

    public final void setBlob(int i,
                              Blob x)
                       throws SQLException

Specified by:
  `setBlob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setBlob

    public final void setBlob(int parameterIndex,
                              InputStream inputStream)
                       throws SQLException

Specified by:
  `setBlob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setBlob

    public final void setBlob(int parameterIndex,
                              InputStream inputStream,
                              long length)
                       throws SQLException

Specified by:
  `setBlob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setClob

    public final void setClob(int parameterIndex,
                              Clob clobValue)
                       throws SQLException

Specified by:
  `setClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setClob

    public final void setClob(int parameterIndex,
                              Reader reader)
                       throws SQLException

Specified by:
  `setClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setClob

    public final void setClob(int parameterIndex,
                              Reader reader,
                              long length)
                       throws SQLException

Specified by:
  `setClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNClob

    public final void setNClob(int parameterIndex,
                               NClob value)
                        throws SQLException

Specified by:
  `setNClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNClob

    public final void setNClob(int parameterIndex,
                               Reader reader)
                        throws SQLException

Specified by:
  `setNClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setNClob

    public final void setNClob(int parameterIndex,
                               Reader reader,
                               long length)
                        throws SQLException

Specified by:
  `setNClob` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setArray

    public final void setArray(int i,
                               Array x)
                        throws SQLServerException

Specified by:
  `setArray` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setDate

    public final void setDate(int n,
                              Date x,
                              Calendar cal)
                       throws SQLServerException

Specified by:
  `setDate` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setDate

    public final void setDate(int n,
                              Date x,
                              Calendar cal,
                              boolean forceEncrypt)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setTime

    public final void setTime(int n,
                              Time x,
                              Calendar cal)
                       throws SQLServerException

Specified by:
  `setTime` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setTime

    public final void setTime(int n,
                              Time x,
                              Calendar cal,
                              boolean forceEncrypt)
                       throws SQLServerException

Throws:
  `SQLServerException`

#### setTimestamp

    public final void setTimestamp(int n,
                                   Timestamp x,
                                   Calendar cal)
                            throws SQLServerException

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setTimestamp

    public final void setTimestamp(int n,
                                   Timestamp x,
                                   Calendar cal,
                                   boolean forceEncrypt)
                            throws SQLServerException

Throws:
  `SQLServerException`

#### setNull

    public final void setNull(int paramIndex,
                              int sqlType,
                              String typeName)
                       throws SQLServerException

Specified by:
  `setNull` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### getParameterMetaData

    public final ParameterMetaData getParameterMetaData()
                                                 throws SQLServerException

Specified by:
  `getParameterMetaData` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setURL

    public final void setURL(int parameterIndex,
                             URL x)
                      throws SQLServerException

Specified by:
  `setURL` in interface `PreparedStatement`
Throws:
  `SQLServerException`

#### setRowId

    public final void setRowId(int parameterIndex,
                               RowId x)
                        throws SQLException

Specified by:
  `setRowId` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setSQLXML

    public final void setSQLXML(int parameterIndex,
                                SQLXML xmlObject)
                         throws SQLException

Specified by:
  `setSQLXML` in interface `PreparedStatement`
Throws:
  `SQLException`

#### executeUpdate

    public final int executeUpdate(String sql)
                            throws SQLServerException

Description copied from class: `SQLServerStatement`
Execute a JDBC update

Specified by:
  `executeUpdate` in interface `Statement`
Overrides:
  `executeUpdate` in class `SQLServerStatement`
Parameters:
  `sql` - the SQL query
Returns:
  The number of rows updated.
Throws:
  `SQLServerException` - The SQL was invalid.

#### execute

    public final boolean execute(String sql)
                          throws SQLServerException

Description copied from class: `SQLServerStatement`
Execute an update or query.

Specified by:
  `execute` in interface `Statement`
Overrides:
  `execute` in class `SQLServerStatement`
Parameters:
  `sql` - The update or query.
Returns:
  True if a result set was generated.
Throws:
  `SQLServerException` - The SQL statement was not valid.

#### executeQuery

    public final ResultSet executeQuery(String sql)
                                 throws SQLServerException

Description copied from class: `SQLServerStatement`
Execute a result set query

Specified by:
  `executeQuery` in interface `Statement`
Overrides:
  `executeQuery` in class `SQLServerStatement`
Parameters:
  `sql` - the SQL query
Returns:
  a JDBC result set.
Throws:
  `SQLServerException` - The SQL was invalid.

#### addBatch

    public void addBatch(String sql)
                  throws SQLServerException

Specified by:
  `addBatch` in interface `Statement`
Overrides:
  `addBatch` in class `SQLServerStatement`
Throws:
  `SQLServerException`